﻿# -*- encoding: UTF-8 -*--*-
import uno, unohelper
from com.sun.star.task import XJobExecutor
from com.sun.star.lang import XServiceInfo
#from com.sun.star.lang import Locale
import calendar, locale
from vnd.pycalendar import Xpycalendar

IMPL_NAME = 'vnd.pycalendar'

class SIC(unohelper.Base, XServiceInfo, XJobExecutor, Xpycalendar):
	def __init__(self, ctx):
		self.ctx = ctx
		
	def trigger(self,args):
		locale.setlocale(locale.LC_ALL, '')
		aConfigProvider = self.ctx.ServiceManager.createInstance("com.sun.star.configuration.ConfigurationProvider")
		prop = uno.createUnoStruct('com.sun.star.beans.PropertyValue')
		prop.Name = "nodepath"
		prop.Value = "/org.openoffice.Setup/L10N"
		uilocale = aConfigProvider.createInstanceWithArguments("com.sun.star.configuration.ConfigurationAccess",(prop,)).getByName("ooLocale")[0:2]
		self.run1(uilocale)
				
	def run1(self, uilocale):
		import pc
		pc1 = pc.main(self.ctx)
		if uilocale=="ru":
			from pc.ru import strs
		else:
			from pc.en import strs
		pc1.pycalendar(strs)
		
	# user input something like servicename, structname...
	# XServiceInfo
	def getImplementationName(self):
		return IMPL_NAME
	def supportsService(self, ServiceName):
		return ServiceName == IMPL_NAME
	def getSupportedServiceNames(self):
		return (IMPL_NAME,)
		
	# Xpycalendar
	def calendar(self, Year):
		return calendar.calendar(Year)
	def MonthAbbr(self):
		return tuple(calendar.month_abbr)
	def MonthName(self):
		return tuple(calendar.month_name)
	def DayAbbr(self):
		return tuple(calendar.day_abbr)
	def DayName(self):
		return tuple(calendar.day_name)
	def MonthRange(self, Year, Month):
		return tuple(calendar.monthrange(Year, Month))
	def Month(self, Year, Month):
		return calendar.month(Year, Month)
	def MonthCalendar(self, Year, Month):
		A = calendar.monthcalendar(Year, Month)
		B=tuple([tuple(A[n]) for n in range(len(A))])
		return B

# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(SIC, IMPL_NAME, ('com.sun.star.task.Job',),)
