﻿# -*- encoding: UTF-8 -*--*-
import uno, unohelper
from com.sun.star.awt import Rectangle, WindowDescriptor
from com.sun.star.awt.WindowClass import MODALTOP, SIMPLE as WC_SIMPLE
from com.sun.star.awt.VclWindowPeerAttribute import OK, OK_CANCEL, YES_NO, YES_NO_CANCEL, RETRY_CANCEL, DEF_OK, DEF_CANCEL, DEF_RETRY, DEF_YES, DEF_NO
from com.sun.star.awt.WindowAttribute import BORDER as WA_BORDER, SHOW as WA_SHOW, SIZEABLE as WA_SIZEABLE, MOVEABLE as WA_MOVEABLE, CLOSEABLE as WA_CLOSEABLE
from com.sun.star.awt.PosSize import POSSIZE as PS_POSSIZE, SIZE as PS_SIZE
from com.sun.star.awt import Rectangle, WindowDescriptor
from com.sun.star.view.SelectionType import SINGLE as ST_SINGLE
from com.sun.star.style.HorizontalAlignment import RIGHT as HA_RIGHT
import calendar
from . import listeners
from datetime import datetime, date

class Dialogs(object):
	def __init__(self, ctx, document):
		self.ctx = ctx
		smgr = ctx.getServiceManager()
		self.smgr = smgr
		self.document = document
		self.grid = None
		self.cont = None
		self.Year = 0
		self.Month = 0
		self.WindowHeight = 190
		self.WindowWidth = 260
		self.WindowPosX = 800
		self.WindowPosY = 100
		self.listbox = None
		self.label = None
		self.obtn = None
		self.numericfield = None
		self.SelectionY = None
		self.SelectionX = None
		self.cl=[[]]
		self.Day = 0
		self.isodate = ''
		from com.sun.star.beans import PropertyValue
		node = PropertyValue()
		node.Name = 'nodepath'
		node.Value = '/vnd.pycalendar.config/settings'
		self.node = node
		self.listeners = {}
		#locale.setlocale(locale.LC_ALL, '')
		self.FirstWeekDay = 0 #calendar.MONDAY == 0, calendar.SUNDAY == 6
		self.calr = calendar
		self.DateFormatKey = 'YYYY-MM-DD'
		self.NumberFormat = 84
		#self.calr_cal = calr.Calendar(self.FirstWeekDay)
	def MessageBox(self, MsgText, MsgTitle=''):
		ParentWin = self.document.getCurrentController().Frame.ContainerWindow
		descriptor = WindowDescriptor()
		descriptor.Type = MODALTOP
		descriptor.WindowServiceName ='infobox' #available MsgTypes('messbox', 'infobox', 'errorbox', 'warningbox', 'querybox')
		descriptor.ParentIndex = -1
		descriptor.Parent = ParentWin
		descriptor.WindowAttributes = OK #OK, OK_CANCEL, YES_NO, YES_NO_CANCEL, RETRY_CANCEL, DEF_OK, DEF_CANCEL, DEF_RETRY, DEF_YES, DEF_NO
		tk = ParentWin.getToolkit()
		msgbox = tk.createWindow(descriptor)
		msgbox.setMessageText(MsgText)
		msgbox.setCaptionText(MsgTitle)
		return msgbox.execute()
	# taken from the MRI extension: http://extensions.services.openoffice.org/project/mri
	def create_floating_window(self, strs, ev=None):
		ParentWin = self.document.getCurrentController().Frame.ContainerWindow
		smgr=self.smgr
		ctx=self.ctx
		self.config_read()
		if self.FirstWeekDay == 6:
			self.calr.setfirstweekday(calendar.SUNDAY)
		else:
			self.calr.setfirstweekday(calendar.MONDAY)
		x = self.WindowPosX
		y = self.WindowPosY
		
		NumberFormats = self.document.NumberFormats
		Le = NumberFormats.getByKey(0).Locale #smgr.createInstanceWithContext('com.sun.star.lang.Locale', ctx)
		DFK = self.DateFormatKey
		#mri = smgr.createInstanceWithContext("mytools.Mri",ctx)
		#mri.inspect(NumberFormats)
		self.NumberFormat = NumberFormats.queryKey( DFK, Le, True )
		if self.NumberFormat == -1:
			try:
				self.NumberFormat = NumberFormats.addNew( DFK, Le )
			except:
				self.MessageBox(strs[1] + DFK + strs[2])
				self.NumberFormat = 84
		
		toolkit = ParentWin.getToolkit()
		frame = smgr.createInstanceWithContext('com.sun.star.frame.Frame', ctx)
		rect = Rectangle(x, y, self.WindowWidth, self.WindowHeight)
		window = toolkit.createWindow(WindowDescriptor(WC_SIMPLE, 'floatingwindow', ParentWin, -1, rect, WA_BORDER + WA_SHOW + WA_SIZEABLE + WA_MOVEABLE + WA_CLOSEABLE))
		frame.initialize(window)
		self.window = window
		cont = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlContainer', ctx)
		cont_model = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlContainerModel', ctx)
		cont.setModel(cont_model)
		cont.createPeer(toolkit,window)
		cont.setPosSize(0,0,self.WindowWidth,self.WindowHeight,PS_POSSIZE)
		#cont_model.BackgroundColor = window.getAccessibleContext().Background
		cont_model.BackgroundColor = 0xFAFAFA
		frame.setComponent(cont,None)
		Y = datetime.now().year
		M = datetime.now().month
		D = datetime.now().day
		self.isodate = date(Y, M, D).isoformat()
		self.Year = Y
		self.Month = M
		self.Day = D
		self.cont = cont
		grid = self.gridcal(Y,M,self.WindowHeight,self.WindowWidth)
		listbox = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlListBox', ctx)
		listbox_model = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlListBoxModel', ctx)
		listbox_model.setPropertyValues(('Dropdown','LineCount','FontHeight',),(True,12,12,))
		Months = tuple(self.calr.month_name)
		listbox_model.StringItemList = Months[1:13]
		listbox.setModel(listbox_model)
		listbox.setPosSize(4, 1, self.WindowWidth/2-6, 28, PS_POSSIZE)
		cont.addControl('listbox', listbox)
		listbox.selectItemPos(M-1, True)
		self.listbox = listbox
		
		numericfield = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlNumericField', ctx)
		numericfield_model = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlNumericFieldModel', ctx)
		numericfield_model.setPropertyValues(('DecimalAccuracy','Spin','Value','FontHeight',),(0,True,Y,13,))
		numericfield.setModel(numericfield_model)
		numericfield.setPosSize(self.WindowWidth/2+2, 1, self.WindowWidth/2-6, 28, PS_POSSIZE)
		cont.addControl('numericfield', numericfield)
		self.numericfield = numericfield
		
		
		obtn = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlButton', ctx)		
		obtn_model = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlButtonModel', ctx)
		obtn_model.setPropertyValues( ('Label',), (strs[0],) )
		obtn.setModel(obtn_model)
		obtn.setPosSize(4, self.WindowHeight - 29, self.WindowWidth/2-6, 28, PS_POSSIZE)
		cont.addControl('obtn', obtn)
		self.obtn = obtn
		
		label = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlFixedText', ctx)		
		label_model = smgr.createInstanceWithContext('com.sun.star.awt.UnoControlFixedTextModel', ctx)
		label_model.setPropertyValues( ('FontHeight',), (13,) )
		label.setModel(label_model)
		label.Text = self.isodate
		label.setPosSize(self.WindowWidth/2+2, self.WindowHeight - 29, self.WindowWidth/2-6, 28, PS_POSSIZE)
		cont.addControl('label', label)
		self.label = label
		
		#mri = smgr.createInstanceWithContext("mytools.Mri",ctx)
		#mri.inspect(grid)
		win_listener = listeners.GridWindowListener(self)
		window.addWindowListener(win_listener)
		self.listeners['win'] = win_listener
		
		window.setVisible(True)
		
		cont_listener = listeners.GridWindowEventListener(self)
		cont.addEventListener(cont_listener)
		self.listeners['cont'] = cont_listener
		
		grid_listener = listeners.GridSelectionListener(self)
		grid.addSelectionListener(grid_listener)
		self.listeners['grid'] = grid_listener
		
		grid_mouse_listener = listeners.GridMouseListener(self)
		grid.addMouseListener(grid_mouse_listener)
		self.listeners['gridmouse'] = grid_mouse_listener
		
		list_listener = listeners.ListItemListener(self)
		listbox.addItemListener(list_listener)
		self.listeners['list'] = list_listener
		
		numericfield_listener = listeners.NumericFieldTextListener(self)
		numericfield.addTextListener(numericfield_listener)
		self.listeners['numericfield'] = numericfield_listener
		
		obtn_listener = listeners.ButtonActionListener(self)
		obtn.addActionListener(obtn_listener)
		self.listeners['obtn'] = obtn_listener
		
		label_listener = listeners.LabelMouseListener(self)
		label.addMouseListener(label_listener)
		self.listeners['label'] = label_listener
		
	def gridcal(self, Year, Month, Height, Width):
		smgr=self.smgr
		ctx=self.ctx
		grid = smgr.createInstanceWithContext('com.sun.star.awt.grid.UnoControlGrid', ctx)
		grid_model = smgr.createInstanceWithContext('com.sun.star.awt.grid.UnoControlGridModel', ctx)
		grid_model.setPropertyValues(('SelectionModel', 'ShowColumnHeader', 'ShowRowHeader',),(ST_SINGLE, True, True,))
		grid.setModel(grid_model)
		grid.setPosSize(0, 30, Width, Height-60, PS_POSSIZE)
		gridModel = grid.getModel()
		dataModel = smgr.createInstanceWithContext('com.sun.star.awt.grid.DefaultGridDataModel', ctx)
		colModel = smgr.createInstanceWithContext('com.sun.star.awt.grid.DefaultGridColumnModel', ctx)
		da = self.calr.day_abbr
		Ts=[]
		if self.FirstWeekDay == 6:
			Ts.append(da[6])
			Ts += da[0:6]
		else:
			Ts = da
		for T in Ts:
			gridCol = smgr.createInstanceWithContext('com.sun.star.awt.grid.GridColumn', ctx)
			gridCol.Title = T
			gridCol.HorizontalAlign = HA_RIGHT
			colModel.addColumn(gridCol)
		gridModel.ColumnModel = colModel
		#gridModel.GridDataModel = dataModel
		self.cont.addControl('grid', grid)
		self.grid = grid
		self.cal()
		return grid
	def cal(self):
		smgr=self.smgr
		ctx=self.ctx
		self.grid.Model.GridDataModel.removeAllRows()
		cl = self.calr.monthcalendar(self.Year,self.Month)
		totaldays = self.calr.monthrange(self.Year,self.Month)[1]
		upn = len(cl)
		wn=[]
		directive = ('%U' if self.FirstWeekDay == 6 else '%W')
		for j in range(upn):
			dy = cl[j][6]
			if dy == 0: dy = totaldays
			wn.append(int(date(self.Year, self.Month, dy).strftime(directive)))
		self.cl = cl
		for n in range(upn):
			self.grid.Model.GridDataModel.addRow(str(wn[n]),tuple([str(x or '') for x in cl[n]]))
		
	def config_read(self):
		config_provider = self.smgr.createInstanceWithContext( 
			'com.sun.star.configuration.ConfigurationProvider', self.ctx)
		config_reader = config_provider.createInstanceWithArguments( 
			'com.sun.star.configuration.ConfigurationAccess', (self.node,))
		self.WindowHeight = config_reader.Height
		self.WindowWidth = config_reader.Width
		self.WindowPosX = config_reader.XPosition
		self.WindowPosY = config_reader.YPosition
		self.FirstWeekDay = config_reader.FirstWeekDay
		self.DateFormatKey = config_reader.DateFormatKey
		
	def config_write(self):
		config_provider = self.smgr.createInstanceWithContext( 
			'com.sun.star.configuration.ConfigurationProvider', self.ctx)
		config_writer = config_provider.createInstanceWithArguments( 
			'com.sun.star.configuration.ConfigurationUpdateAccess', (self.node,))
		#names = (Height, Width, XPosition, YPosition)
		#values =(self.WindowHeight, self.WindowWidth, self.WindowPosX, self.WindowPosY)
		#config_writer.setPropertyValues(names, values)
		config_writer.Height = self.WindowHeight
		config_writer.Width = self.WindowWidth
		config_writer.XPosition = self.WindowPosX
		config_writer.YPosition = self.WindowPosY
		config_writer.commitChanges()
