﻿# -*- encoding: UTF-8 -*--*-
import uno, unohelper
from com.sun.star.awt import XWindowListener, XMouseListener, XItemListener, \
XTextListener, XActionListener
from com.sun.star.lang import XEventListener
from com.sun.star.awt.grid import XGridSelectionListener
from com.sun.star.awt.PosSize import SIZE as PS_SIZE, \
POS as PS_POS, POSSIZE as PS_POSSIZE
from datetime import datetime, date

class GridWindowListener(unohelper.Base,XWindowListener):
	def __init__(self,cast):
		self.cast = cast
	def disposing(self,ev): pass
	def windowMoved(self,ev):
		self.cast.WindowPosX = ev.X
		self.cast.WindowPosY = ev.Y
	def windowShown(self,ev): pass
	def windowHidden(self,ev): pass
	def windowResized(self,ev):
		grid = self.cast.grid
		X = ev.Width
		Y = ev.Height
		self.cast.WindowWidth = X
		self.cast.WindowHeight = Y
		X2=X/2
		self.cast.cont.setPosSize(0, 0, X, Y, PS_SIZE)
		self.cast.obtn.setPosSize(4, Y-29, X2-6, 28, PS_POSSIZE)
		self.cast.label.setPosSize(X2+2, Y-29, X2-6, 28, PS_POSSIZE)
		self.cast.listbox.setPosSize(4, 1, X2-6, 28, PS_SIZE)
		self.cast.numericfield.setPosSize(X2+2, 1, X2-6, 28, PS_POSSIZE)
		grid.setPosSize(0, 0, X, Y-60, PS_SIZE)

class GridMouseListener(unohelper.Base, XMouseListener):
	def __init__(self, cast):
		self.cast = cast
	def disposing(self,oev): pass
	def mouseReleased(self,mEv): pass
	def mouseEntered(self,mEv): pass
	def mouseExited(self,mEv): pass
	def mousePressed(self, mEv):
		if mEv.ClickCount == 1:
			#ColWidth = mEv.Source.Model.ColumnModel.Columns[0].ColumnWidth
			ColWidth = (self.cast.WindowWidth-15)/7
			X = mEv.X
			self.cast.SelectionX=int((X-15)/ColWidth)
			self.cast.Day = self.cast.cl[self.cast.SelectionY][self.cast.SelectionX]
			self.cast.isodate = date(self.cast.Year, self.cast.Month, self.cast.Day).isoformat()
			self.cast.label.Text = self.cast.isodate
		elif mEv.ClickCount == 2:
			CSn=[]
			CS = self.cast.document.CurrentSelection
			if CS.supportsService('com.sun.star.sheet.SheetCellRanges'):
				for i in range(CS.Count):
					CSn.append(CS.getByIndex(i))
			else:
				CSn.append(CS)
			for Sn in CSn:
				A=Sn.DataArray
				L=len(A)
				W=len(A[0])
				B=tuple([tuple([self.cast.isodate]*W) for n in range(L)])
				Sn.setFormulaArray(B)
				Sn.NumberFormat = self.cast.NumberFormat

class LabelMouseListener(unohelper.Base, XMouseListener):
	def __init__(self, cast):
		self.cast = cast
	def disposing(self,oev): pass
	def mouseReleased(self,mEv): pass
	def mouseEntered(self,mEv): pass
	def mouseExited(self,mEv): pass
	def mousePressed(self, mEv):
		if mEv.ClickCount == 2:
			CSn=[]
			CS = self.cast.document.CurrentSelection
			if CS.supportsService('com.sun.star.sheet.SheetCellRanges'):
				for i in range(CS.Count):
					CSn.append(CS.getByIndex(i))
			else:
				CSn.append(CS)
			for Sn in CSn:
				A=Sn.DataArray
				L=len(A)
				W=len(A[0])
				B=tuple([tuple([self.cast.isodate]*W) for n in range(L)])
				Sn.setFormulaArray(B)
				Sn.NumberFormat = self.cast.NumberFormat
		
class ListItemListener(unohelper.Base, XItemListener):
	def __init__(self, cast):
		self.cast = cast
	def disposing(self, oev): pass
	def itemStateChanged(self, iEv):
		self.cast.Month = iEv.Selected+1
		self.cast.cal()
		self.cast.label.Text = date(self.cast.Year, self.cast.Month, self.cast.Day).isoformat()

class NumericFieldTextListener(unohelper.Base, XTextListener):
	def __init__(self, cast):
		self.cast = cast
	def disposing(self, oev): pass
	def textChanged(self, tEv):
		self.cast.Year = int(tEv.Source.Text)
		self.cast.cal()
		self.cast.label.Text = date(self.cast.Year, self.cast.Month, self.cast.Day).isoformat()
		
class GridSelectionListener(unohelper.Base, XGridSelectionListener):
	def __init__(self, cast):
		self.cast = cast
	def selectionChanged(self, ev):
		self.cast.SelectionY = ev.Row
		self.cast.Day = self.cast.cl[self.cast.SelectionY][self.cast.SelectionX]
		self.cast.label.Text = date(self.cast.Year, self.cast.Month, self.cast.Day).isoformat()

class ButtonActionListener(unohelper.Base, XActionListener):
	def __init__(self, cast):
		self.cast = cast
	def disposing(self, eventObject): pass
	def actionPerformed(self, aEv):
		self.cast.Year = datetime.now().year
		self.cast.Month = datetime.now().month
		self.cast.Day = datetime.now().day
		self.cast.isodate = date(self.cast.Year, self.cast.Month, self.cast.Day).isoformat()
		self.cast.listbox.selectItemPos(self.cast.Month-1, True)
		self.cast.numericfield.Text = str(self.cast.Year)
		self.cast.label.Text = self.cast.isodate

class GridWindowEventListener(unohelper.Base, XEventListener):
	def __init__(self,cast):
		self.cast = cast
	def disposing(self, eEv):
		del self.cast.listeners
		del self.cast.cl
		self.cast.config_write()
		self.cast.grid = None
		self.cast.cont = None
		self.cast = None
